#include <LiquidCrystal.h>
#include <OneWire.h>
#include <EEPROM.h>
#include <Servo.h> 
//////////////////Переменные для кнопок///////////////////////////////////////////////////////
byte butPin = 0;                               // вход кнопок
int val;                                       // знач. АЦП при нажатой кнопке
byte butPush = 0;                              // код нажатой кнопки
boolean butRel = 1;                            // отпущена ли сейчас кнопка
int butval[8] = {0,742,580,475,400,350,0,0};   // АЦП кнопок
byte butsens = 20;                             // чувствительность кнопок
boolean keysound = 0;                          // включен ли звук кнопок
//////////////////Переменные для работы термо датчиков/////////////////////////////////////////
OneWire  ds(10);                               // на этот пин подключен DS
float T[] = {0,0,0,0};                         // переменная для хранения температуры
float Tp[] = {0,0,0,0};                        // переменная для хранения температуры
byte data[8];                                  // для хранения данных от датчика
byte TotalDS = 0;                              // число найденых датчиков на линии
byte addr[3][8] = {
                   {0,0,0,0,0,0,0,0},
                   {0,0,0,0,0,0,0,0},
                   {0,0,0,0,0,0,0,0},
                   };  
////////////////////Звук////////////////////////////////////////////////////////////////////////
byte buzzer = 13;                               // выход динамика
byte i;                                         // счетчик
byte n;                                         // счетчик
byte m = 0;                                     // счетчик
byte t = 0;                                     // счетчик
///////////////////Переменные для работы таймеров////////////////////////////////////////////////
unsigned long timer = 0;                        // таймер 
unsigned long procStTime = 0;                   // время начала текущего процесса
unsigned long StTime = 0;                       // время запуска программы
////////////////////Переменные для работы процесса дистилляции///////////////////////////////////
byte Stop = 0;                                  // причина останова
byte Step = 0;                                  // шаг программы
boolean running = false;                        // состояние программы
boolean is_h = true;                            // отбирать ли головы
boolean is_b = true;                            // отбирать ли тело(хвосты)
float Th = 89;                                  // температура окончания отбора голов
float Tb = 93;                                  // температура начала отбора хвостов
float Ts = 97;                                  // температура при которой останавливаем процесс
float Tw = 25;                                  // max температура охлаждающей воды
float Tc = 50;                                  // температура при которой включаем воду
float Tr = 75;                                  // температура отключения разгона
/////////////////Переменные для отображения информации на дисплее и работы меню////////////////////
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);          //инициализация LCD
byte menu = 0;                                  // текущий экран
byte power = 0;                                 // мощность для работы плиты
///////////////////////////////////////////////////////////////////////////////////////////////////
Servo myservo;  // create servo object to control a servo 
/////////////////параметры выходов для плиты///////////////////////////////////////////////////////
int PowerPlane = 6;
int Minus = 7;
int Plus = 8;
int sensePin = 1;
////////////////////////////////////////////////////////////////////////////////////////////////////////
void setup()
{
   
  lcd.begin(2, 16);                             //Задаются параметры дисплея
  pinMode(buzzer, OUTPUT);                      //Задается выход для динамика
  read_DS();                                    //Считываем адреса датчиков из памяти
  keysound = EEPROM.read(241);                  //Восстанавливается звук калвиатуры из памяти
  butsens = EEPROM.read(242); if (butsens < 5 || butsens > 100) { butsens = 20;}
  tone(buzzer, 1000); // включаем пищалку. Это сигнализация на случай если пропадет и снова появится питание
  analogReference (DEFAULT);
  pinMode(PowerPlane, OUTPUT); 
  pinMode(Plus, OUTPUT); 
  pinMode(Minus, OUTPUT); 
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
void loop()
{ 
///////////////////////////Получение информации с трех датчиков температуры///////////////////////////////////
    ds.reset();
    ds.write(0xCC,1);          // пропуск ROM
    ds.write(0x44,1);          // запускаем конвертацию
    for( n = 1; n < 90; n++)   //ждем 900 мс
     { 
      delay(10);            
      if (analogRead(butPin) > 100 && butRel) { Menu(button ()); } //периодически проверяя не нажата ли кнопка
      if (analogRead(butPin) < 100)           {butRel=1;}
     }
    for( n = 0; n < 4; n++) 
     {
      ds.reset();
      ds.select(addr[n]);
      ds.write(0xBE);         
      for ( i = 0; i < 9; i++) {data[i] = ds.read();} 
      Tp[n] = float((data[1] << 8) + data[0])/16;     
      if (Tp[n] == 85) {} else {T[n]=Tp[n];}         
     }
/////////////////////////////////Таймер/////////////////////////////////////////////////////////////////////     
    timer=millis()/1000;                                // текущее время в сек.
//////////////////////////////Процесс получения спирта//////////////////////////////////////////////////////
    if (running == 0)
       { 
         if (analogRead(sensePin) > 200) // включили плиту 
         {
         digitalWrite(PowerPlane, HIGH);delay(100);digitalWrite(PowerPlane, LOW);
         }
       }  
    if (running) 
      {
       if (analogRead(sensePin) < 10) // включили плиту 
       {
         digitalWrite(PowerPlane, HIGH);delay(100);digitalWrite(PowerPlane, LOW);
         for (m = 0; m <= power; m++)
         {
          delay (400);
          if (m > 0) {digitalWrite(Minus, HIGH);delay(100);digitalWrite(Minus, LOW);}
        } 
       } 
       if (!is_h && Step==0) {Step++;}
       if (!is_b && Step==1) {Step++;}
       if (T[0] > Th && Step == 0) {Stop = 4; running = 0; tone(buzzer, 1000); delay(2000); noTone(buzzer);} // отобрали головы
       if (T[0] > Tb && Step == 1) {Stop = 4; running = 0; tone(buzzer, 1000); delay(2000); noTone(buzzer);} // отобрали тело
       if (T[0] > Ts) {Stop = 0; running = 0; tone(buzzer, 1000); delay(3000); noTone(buzzer);} // все закончили (нормальный останов)
       if (T[1]-T[0] < 2 && T[0] > 80 ) {Stop = 0; running = 0; tone(buzzer, 1000); delay(3000); noTone(buzzer);} // все закончили (нормальный останов)
       if (T[2] > Tw) {Stop = 6; running = 0;} // высокая Т охлаждающей воды
      }
     else {}
    Menu(0);
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int button () 
   {
     butPush = 0; // код нажатой кнопки
     if (keysound) {tone(buzzer, 1000);}
     delay(15);  // задержка для устранения дребезга контактов
     val = analogRead(butPin);  // читаем АЦП порта кнопок (значение от 0 до 1023)
     if (val > (butval[5]-butsens) && val < (butval[5]+butsens)) {butPush = 5;}  
     if (val > (butval[4]-butsens) && val < (butval[4]+butsens)) {butPush = 4;}
     if (val > (butval[3]-butsens) && val < (butval[3]+butsens)) {butPush = 3;}
     if (val > (butval[2]-butsens) && val < (butval[2]+butsens)) {butPush = 2;}
     if (val > (butval[1]-butsens)) {butPush = 1;}
     butRel=0;
     noTone(buzzer);
     return butPush;
   }
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void printTimer () 
   {
    timer=timer-StTime;
    n=timer/60;
    if (n < 100) lcd.print(" "); 
    if (n < 10) lcd.print(" "); 
    lcd.print(n,DEC);
    lcd.print(":"); 
    n=timer-(timer/60)*60;
    if (n < 10) lcd.print("0"); 
    lcd.print(n,DEC);    
    }
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
byte read_DS() 
   {
    for (n=0; n<3; n++) 
    {
     for (i=0; i<8; i++) 
     {
      addr[n][i] = EEPROM.read(128+n*8+i);
     }
    }
    return 0;
   }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
byte write_DS() 
   {
    for (i=0; i<8; i++) 
    {
     if (m==0) {EEPROM.write(128+t*8+i,0);}
     else {EEPROM.write(128+t*8+i,addr[m-1][i]);}
    }
    return 0;
   }
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void Menu(int butPush) 
   {
    lcd.clear();
    if (Stop) {menu=1;}
    switch (menu) 
     {
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////       
      case 0: // температуры
        lcd.setCursor(0,0);
        lcd.print(T[0]);
        lcd.setCursor(5,0);
        lcd.print("/");
        lcd.print(T[1]);
        lcd.setCursor(11,0);
        lcd.print("/");
        lcd.print(T[2]);
        if (butPush == 3)                                          
          {
           if (running) {running=0; Menu(0);}
           else {running=1; Step=0; StTime=timer;  Menu(0);}    
          }
        if (running) 
          {
           if (butPush == 2) {power = power - 1; if (power < 0) {power = 0;} digitalWrite(Plus, HIGH);delay(100);digitalWrite(Plus, LOW);}  
           if (butPush == 4) {power = power + 1; if (power > 4) {power = 4;} digitalWrite(Minus, HIGH);delay(100);digitalWrite(Minus, LOW);}
           lcd.setCursor(0,1);
           lcd.print("Pow ");
           if (power == 0) {lcd.print ("2000");}
           if (power == 1) {lcd.print ("1600");}
           if (power == 2) {lcd.print ("1200");}
           if (power == 3) {lcd.print ("800");}
           if (power == 4) {lcd.print ("400");}
           
           timer=timer-StTime;
           lcd.setCursor(11,1);
           lcd.print(timer/60);
           lcd.print(":"); 
           n=timer-(timer/60)*60;
           if (n < 10) lcd.print("0"); 
           lcd.print(n,DEC);   
           
          }
        else {lcd.setCursor(0,1); lcd.print("Pause"); running = 0;}
      if (butPush == 1) {menu=2; Menu(0);}  
      if (butPush == 5) {menu=2; Menu(0);}
      break;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
      case 1: // статус портов
        if (Stop) {
          lcd.print("STOP");
          lcd.setCursor(0,1);
          lcd.print("Error ");
          lcd.print(Stop, DEC);
          tone(buzzer, 1000);
          if (butPush == 1) {Stop=0; Menu(0);}
          if (butPush == 2) {Stop=0; Menu(0);}
          if (butPush == 3) {Stop=0; running=1; Step++; Menu(0);}
          if (butPush == 4) {Stop=0; running=1; Step++; Menu(0);}
          if (butPush == 5) {Stop=0; running=1; Step++; Menu(0);}
        }
        else {
        lcd.setCursor(0,1);
        lcd.print(T[0]);
        lcd.setCursor(7,1); 
        if (running) {printTimer();} else {lcd.print("OFF");}
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
        }
      break;
      
      case 2: // меню настроек
        lcd.print("Setup");
        lcd.setCursor(0,1);
        lcd.print("Press OK");
        if (butPush == 1) {menu=0; Menu(0);}
        if (butPush == 3) {menu=40; Menu(0);}
        if (butPush == 5) {menu=0; Menu(0);}
      break;      
      
//////////////////////////////////////////////////////////////////////////////////////

      case 40: // отбирать головы?
        lcd.print("Get first?");
        lcd.setCursor(0,1);
        if (is_h) {lcd.print("     Yes");} else {lcd.print("       NO");}
        if (butPush == 1) {menu=48; Menu(0);}
        if (butPush == 2) {is_h=0; Menu(0);}
        if (butPush == 3) {menu=0; Menu(0);}
        if (butPush == 4) {is_h=1; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;
      case 41: // T отбора голов
        lcd.print("First T");
        lcd.setCursor(0,1);
        lcd.print(Th, DEC);
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {Th=Th-0.25; Menu(0);}
        if (butPush == 3) {menu=0; Menu(0);}
        if (butPush == 4) {Th=Th+0.25; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;
      case 42: // отбирать хвосты?
        lcd.print("Get last?");
        lcd.setCursor(0,1);
        if (is_b) {lcd.print("     Yes");} else {lcd.print("       No");}
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {is_b=0; Menu(0);}
        if (butPush == 3) {menu=0; Menu(0);}
        if (butPush == 4) {is_b=1; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;
      case 43: // Т отбора тела
        lcd.print("T get body");
        lcd.setCursor(0,1);
        lcd.print(Tb, DEC);
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {Tb=Tb-0.25; Menu(0);}
        if (butPush == 3) {menu=0; Menu(0);}
        if (butPush == 4) {Tb=Tb+0.25; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;
      case 44: // Т останова процесса
        lcd.print("T stop");
        lcd.setCursor(0,1);
        lcd.print(Ts, DEC);
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {Ts=Ts-0.25; Menu(0);}
        if (butPush == 3) {menu=0; Menu(0);}
        if (butPush == 4) {Ts=Ts+0.25; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;
      case 45: // max T охл. воды
        lcd.print("T cool water");
        lcd.setCursor(0,1);
        lcd.print(Tw, DEC);
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {Tw=Tw-0.25; Menu(0);}
        if (butPush == 3) {menu=0; Menu(0);}
        if (butPush == 4) {Tw=Tw+0.25; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;
      case 46: // T отключения разгона
        lcd.print("T down speed");
        lcd.setCursor(0,1);
        lcd.print(Tr, DEC);
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {Tr=Tr-0.25; Menu(0);}
        if (butPush == 3) {menu=0; Menu(0);}
        if (butPush == 4) {Tr=Tr+0.25; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;
      case 47: // Звук кнопок
        lcd.print("Sound Button");
        lcd.setCursor(0,1);
        if (keysound) {lcd.print("    ON");}
        else  {lcd.print("    OFF");}
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2 || butPush == 4) {keysound=!keysound; Menu(0); EEPROM.write(241,keysound);}
        if (butPush == 3) {menu=0; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;      
      
      case 48: // Мощность плиты
        lcd.print("Power ");
        lcd.setCursor(0,1);
        if (power == 0) {lcd.print ("2000");}
        if (power == 1) {lcd.print ("1600");}
        if (power == 2) {lcd.print ("1200");}
        if (power == 3) {lcd.print (" 800");}
        if (power == 4) {lcd.print (" 400");}
        
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {power=power-1; Menu(0); if (power < 1) power = 4;}
        if (butPush == 3) {menu=0; Menu(0);}
        if (butPush == 4) {power=power+1; Menu(0); if (power > 4) power = 0;}
        if (butPush == 5) {menu=40; Menu(0);}
      break;
    
      case 100: // меню настроек датчиков DS1820
        lcd.print("T");
        lcd.print(t+1,DEC);
        lcd.setCursor(0,1);
        if (m==0) {lcd.print("Not found");}
           else {lcd.print(T[m-1],DEC);}
        if (butPush == 1) {if (t==0) {menu=101;} else {t--;} Menu(0);}
        if (butPush == 2) {if (m==0) {} else {m--;} Menu(0);}
        if (butPush == 3) {write_DS(); lcd.setCursor(0,1); lcd.print("Save EEPROM"); tone(buzzer, 1000); delay(1000); noTone(buzzer); menu=100; Menu(0);}
        if (butPush == 4) {m++; if (m>(TotalDS)) {m=TotalDS;} Menu(0);}
        if (butPush == 5) {if (t==3) {menu=101;} else {t++;}  Menu(0);}
      break; 

      case 101: // Выход из меню
        lcd.print("Exit from men");
        lcd.setCursor(0,1);
        lcd.print("OK for exit");
        if (butPush == 1) {t=3; menu=100; Menu(0);}
        if (butPush == 3) {menu=52; Menu(0);}
        if (butPush == 5) {t=0; menu=100; Menu(0);}  
      break;      
      }
}

